# Load Balancer Terraform Module

Terraform module to create a load balancer (“application”, “network” or “network”) and related resources in AWS.

<!-- BEGIN_TF_DOCS -->
## Requirements

| Name | Version |
|------|---------|
| terraform | >= 1.5 |
| aws | >= 5.13 |

## Providers

| Name | Version |
|------|---------|
| aws | >= 5.13 |

## Modules

No modules.

## Resources

| Name | Type |
|------|------|
| [aws_lambda_permission.this](https://registry.terraform.io/providers/hashicorp/aws/latest/docs/resources/lambda_permission) | resource |
| [aws_lb.this](https://registry.terraform.io/providers/hashicorp/aws/latest/docs/resources/lb) | resource |
| [aws_lb_listener.alb](https://registry.terraform.io/providers/hashicorp/aws/latest/docs/resources/lb_listener) | resource |
| [aws_lb_listener.non_alb](https://registry.terraform.io/providers/hashicorp/aws/latest/docs/resources/lb_listener) | resource |
| [aws_lb_listener_rule.alb](https://registry.terraform.io/providers/hashicorp/aws/latest/docs/resources/lb_listener_rule) | resource |
| [aws_lb_target_group.this](https://registry.terraform.io/providers/hashicorp/aws/latest/docs/resources/lb_target_group) | resource |
| [aws_lb_target_group_attachment.this](https://registry.terraform.io/providers/hashicorp/aws/latest/docs/resources/lb_target_group_attachment) | resource |
| [aws_wafv2_web_acl_association.this](https://registry.terraform.io/providers/hashicorp/aws/latest/docs/resources/wafv2_web_acl_association) | resource |

## Inputs

| Name | Description | Type | Default | Required |
|------|-------------|------|---------|:--------:|
| access\_logs\_prefix | The S3 bucket prefix. Logs are stored in the root if not configured. Only valid if “var.access\_logs\_enabled” and “var.access\_logs\_s3\_bucket\_name” are set. | `string` | `null` | no |
| access\_logs\_s3\_bucket\_name | The name of the S3 bucket name to store the logs in. Only valid if “var.access\_logs\_enabled” is set. | `string` | `null` | no |
| alb\_listener\_rules | Map of listener. This apply only for “application” load balancer type.<br/>Keys are free values.<br/><br/>- listener\_key (required, string)    : Key of the “var.alb\_listeners” where to add this rule.<br/>- action\_type (required, string)     : Type of routing action. Valid values are “forward”, “redirect”, “fixed-response”, “authenticate-cognito” and “authenticate-oidc”.<br/>- priority (optional, number)        : The priority for the rule between “1” and “50000”. Leaving it unset will automatically set the rule with next available priority after currently existing highest rule. A listener can't have multiple rules with the same priority.<br/><br/>- authenticate\_cognito\_user\_pool\_arn (optional, string)                                                             : ARN of the Cognito user pool.<br/>- authenticate\_cognito\_user\_pool\_client\_id (optional, string)                                                       : ID of the Cognito user pool client.<br/>- authenticate\_cognito\_user\_pool\_domain (optional, string)                                                          : Domain prefix or fully-qualified domain name of the Cognito user pool.<br/>- authenticate\_cognito\_authentication\_request\_extra\_params (optional, map(object({ key = string, value = string }))): Query parameters to include in the redirect request to the authorization endpoint. Max: 10.<br/>- authenticate\_cognito\_on\_unauthenticated\_request (optional, string)                                                : Behavior if the user is not authenticated. Valid values are “deny”, “allow” and “authenticate”.<br/>- authenticate\_cognito\_scope (optional, set(string))                                                                : Set of user claims to be requested from the IdP.<br/>- authenticate\_cognito\_session\_cookie\_name (optional, string)                                                       : Name of the cookie used to maintain session information.<br/>- authenticate\_cognito\_session\_timeout (optional, number)                                                           : Maximum duration of the authentication session, in seconds.<br/><br/>- authenticate\_oidc\_authorization\_endpoint (optional, string)                                                    : Authorization endpoint of the IdP.<br/>- authenticate\_oidc\_client\_id (optional, string)                                                                 : OAuth 2.0 client identifier.<br/>- authenticate\_oidc\_client\_secret (optional, string)                                                             : OAuth 2.0 client secret.<br/>- authenticate\_oidc\_issuer (optional, string)                                                                    : OIDC issuer identifier of the IdP.<br/>- authenticate\_oidc\_token\_endpoint (optional, string)                                                            : Token endpoint of the IdP.<br/>- authenticate\_oidc\_user\_info\_endpoint (optional, string)                                                        : User info endpoint of the IdP.<br/>- authenticate\_oidc\_authentication\_request\_extra\_params (optional, map(object({ key = string, value = string }))): Query parameters to include in the redirect request to the authorization endpoint. Max: 10.<br/>- authenticate\_oidc\_on\_unauthenticated\_request (optional, string)                                                : Behavior if the user is not authenticated. Valid values: “deny”, “allow” and “authenticate”.<br/>- authenticate\_oidc\_scope (optional, set(string))                                                                : Set of user claims to be requested from the IdP.<br/>- authenticate\_oidc\_session\_cookie\_name (optional, string)                                                       : Name of the cookie used to maintain session information.<br/>- authenticate\_oidc\_session\_timeout (optional, number)                                                           : Maximum duration of the authentication session, in seconds.<br/><br/>- fixed\_response\_content\_type (optional, string): Content type. Valid values are “text/plain”, “text/css”, “text/html”, “application/javascript” and “application/json”.<br/>- fixed\_response\_message\_body (optional, string): Message body.<br/>- fixed\_response\_status\_code (optional, number) : TTP response code. Valid values are 2XX, 4XX, or 5XX.<br/><br/>- target\_groups (optional, set(object({key = optional(string), arn = optional(string), weight = optional(number)}))): Set of object of target groups. “key” is the “var.target\_groups”, “arn” is the ARN of the target group, “weight” is the range between 0 and 999. One of “arn” or “key” is mandatory, and you must exclusively use one of “arn” or “key”<br/><br/>- stickiness\_duration (optional, number): Time period, in seconds, during which requests from a client should be routed to the same target group. The range is 1-604800 seconds (7 days).<br/><br/>- redirect\_status\_code (optional, string): HTTP redirect code. The redirect is either permanent (“HTTP\_301”) or temporary (“HTTP\_302”).<br/>- redirect\_host (optional, string)       : Hostname. This component is not percent-encoded. The hostname can contain #{host}.<br/>- redirect\_path (optional, string)       : Absolute path, starting with the leading “/”. This component is not percent-encoded. The path can contain “#{host}”, “#{path}”, and “#{port}”.<br/>- redirect\_port (optional, any)          : Port. Specify a value from 1 to 65535 or “#{port}“.<br/>- redirect\_protocol (optional, string)   : Protocol. Valid values are “HTTP”, “HTTPS”, or “#{protocol}”.<br/>- redirect\_query (optional, string)      : Query parameters, URL-encoded when necessary, but not percent-encoded. Do not include the leading “?”.<br/><br/>- host\_headers (optional, list(string)): List of host header patterns to match. The maximum size of each pattern is 128 characters. Comparison is case insensitive. Wildcard characters supported: \\* (matches 0 or more characters) and ? (matches exactly 1 character). Only one pattern needs to match for the condition to be satisfied.<br/><br/>- http\_headers (optional, set(object({name = string, values = list(string)}))): Keys are free values.<br/>  Values are:<br/>    - name (required, string)        : Name of HTTP header to search. The maximum size is 40 characters. Comparison is case insensitive. Only RFC7240 characters are supported. Wildcards are not supported.<br/>    - values (required, list(string)): List of header value patterns to match. Maximum size of each pattern is 128 characters. Comparison is case insensitive. Wildcard characters supported: \\* (matches 0 or more characters) and ? (matches exactly 1 character). If the same header appears multiple times in the request they will be searched in order until a match is found. Only one pattern needs to match for the condition to be satisfied.<br/><br/>- http\_request\_methods (optional, list(string)): List of HTTP request methods or verbs to match. Maximum size is 40 characters. Only allowed characters are A-Z, hyphen (-) and underscore (\_). Comparison is case sensitive. Wildcards are not supported. Only one needs to match for the condition to be satisfied. AWS recommends that GET and HEAD requests are routed in the same way because the response to a HEAD request may be cached.<br/><br/>- path\_patterns (optional, list(string)): Llist of path patterns to match against the request URL. Maximum size of each pattern is 128 characters. Comparison is case sensitive. Wildcard characters supported: \\* (matches 0 or more characters) and ? (matches exactly 1 character). Only one pattern needs to match for the condition to be satisfied. Path pattern is compared only to the path of the URL, not to its query string.<br/><br/>- query\_strings (optional, set(object({key = string, value = string}))): Query string pairs or values to match. Keys are free values.<br/>  Values are:<br/>   - key (required, string)  : Query string key pattern to match.<br/>   - value (required, string): Query string value pattern to match.<br/><br/>- source\_ips (optional, list(string)): List of source IP CIDR notations to match. You can use both IPv4 and IPv6 addresses. Wildcards are not supported. Condition is satisfied if the source IP address of the request matches one of the CIDR blocks. Condition is not satisfied by the addresses in the “X-Forwarded-For” header, use “http\_headers” condition instead.<br/><br/>- tags (optional, map(string))        : Tags to be applied and merge with this listener. | <pre>map(object({<br/>    listener_key = string<br/>    action_type  = string<br/><br/>    priority = optional(number)<br/><br/>    authenticate_cognito_user_pool_arn                       = optional(string)<br/>    authenticate_cognito_user_pool_client_id                 = optional(string)<br/>    authenticate_cognito_user_pool_domain                    = optional(string)<br/>    authenticate_cognito_authentication_request_extra_params = optional(map(object({ key = string, value = string })))<br/>    authenticate_cognito_on_unauthenticated_request          = optional(string)<br/>    authenticate_cognito_scope                               = optional(set(string))<br/>    authenticate_cognito_session_cookie_name                 = optional(string)<br/>    authenticate_cognito_session_timeout                     = optional(number)<br/><br/>    authenticate_oidc_authorization_endpoint              = optional(string)<br/>    authenticate_oidc_client_id                           = optional(string)<br/>    authenticate_oidc_client_secret                       = optional(string)<br/>    authenticate_oidc_issuer                              = optional(string)<br/>    authenticate_oidc_token_endpoint                      = optional(string)<br/>    authenticate_oidc_user_info_endpoint                  = optional(string)<br/>    authenticate_oidc_authentication_request_extra_params = optional(map(object({ key = string, value = string })))<br/>    authenticate_oidc_on_unauthenticated_request          = optional(string)<br/>    authenticate_oidc_scope                               = optional(set(string))<br/>    authenticate_oidc_session_cookie_name                 = optional(string)<br/>    authenticate_oidc_session_timeout                     = optional(number)<br/><br/>    fixed_response_content_type = optional(string)<br/>    fixed_response_message_body = optional(string)<br/>    fixed_response_status_code  = optional(number)<br/><br/>    target_groups = optional(set(object({<br/>      key    = optional(string)<br/>      arn    = optional(string)<br/>      weight = optional(number)<br/>    })))<br/><br/>    stickiness_duration = optional(number)<br/><br/>    redirect_status_code = optional(string)<br/>    redirect_host        = optional(string)<br/>    redirect_path        = optional(string)<br/>    redirect_port        = optional(any)<br/>    redirect_protocol    = optional(string)<br/>    redirect_query       = optional(string)<br/><br/>    host_headers = optional(list(string))<br/>    http_headers = optional(set(object({<br/>      name   = string<br/>      values = list(string)<br/>    })))<br/><br/>    http_request_methods = optional(list(string))<br/><br/>    path_patterns = optional(list(string))<br/><br/>    query_strings = optional(set(object({<br/>      key   = string<br/>      value = string<br/>    })))<br/><br/>    source_ips = optional(list(string))<br/><br/>    tags = optional(map(string))<br/>  }))</pre> | `{}` | no |
| alb\_listeners | Map of listeners. This applies only for “application” load balancer types. For “network” and “gateway” load balancer type, use “var.listeners”<br/>Keys are free values.<br/>- action\_type (required, string)     : Type of routing action. Valid values are “forward”, “redirect”, “fixed-response”, “authenticate-cognito” and “authenticate-oidc”.<br/>- port (required, number)            : Port on which the load balancer is listening.<br/>- protocol (required, string)        : Protocol for connections from clients to the load balancer. Valid values are “HTTP” and “HTTPS”.<br/>- certificate\_arn (optional, string) : ARN of the default SSL server certificate. Required if protocol “HTTPS”.<br/>- ssl\_policy (optional, string)      : Name of the SSL Policy for the listener. Required if protocol “HTTPS”.<br/><br/>- authenticate\_cognito\_user\_pool\_arn (optional, string)                                                             : ARN of the Cognito user pool.<br/>- authenticate\_cognito\_user\_pool\_client\_id (optional, string)                                                       : ID of the Cognito user pool client.<br/>- authenticate\_cognito\_user\_pool\_domain (optional, string)                                                          : Domain prefix or fully-qualified domain name of the Cognito user pool.<br/>- authenticate\_cognito\_authentication\_request\_extra\_params (optional, map(object({ key = string, value = string }))): Query parameters to include in the redirect request to the authorization endpoint. Max: 10.<br/>- authenticate\_cognito\_on\_unauthenticated\_request (optional, string)                                                : Behavior if the user is not authenticated. Valid values are “deny”, “allow” and “authenticate”.<br/>- authenticate\_cognito\_scope (optional, set(string))                                                                : Set of user claims to be requested from the IdP.<br/>- authenticate\_cognito\_session\_cookie\_name (optional, string)                                                       : Name of the cookie used to maintain session information.<br/>- authenticate\_cognito\_session\_timeout (optional, number)                                                           : Maximum duration of the authentication session, in seconds.<br/><br/>- authenticate\_oidc\_authorization\_endpoint (optional, string)                                                    : Authorization endpoint of the IdP.<br/>- authenticate\_oidc\_client\_id (optional, string)                                                                 : OAuth 2.0 client identifier.<br/>- authenticate\_oidc\_client\_secret (optional, string)                                                             : OAuth 2.0 client secret.<br/>- authenticate\_oidc\_issuer (optional, string)                                                                    : OIDC issuer identifier of the IdP.<br/>- authenticate\_oidc\_token\_endpoint (optional, string)                                                            : Token endpoint of the IdP.<br/>- authenticate\_oidc\_user\_info\_endpoint (optional, string)                                                        : User info endpoint of the IdP.<br/>- authenticate\_oidc\_authentication\_request\_extra\_params (optional, map(object({ key = string, value = string }))): Query parameters to include in the redirect request to the authorization endpoint. Max: 10.<br/>- authenticate\_oidc\_on\_unauthenticated\_request (optional, string)                                                : Behavior if the user is not authenticated. Valid values: “deny”, “allow” and “authenticate”.<br/>- authenticate\_oidc\_scope (optional, set(string))                                                                : Set of user claims to be requested from the IdP.<br/>- authenticate\_oidc\_session\_cookie\_name (optional, string)                                                       : Name of the cookie used to maintain session information.<br/>- authenticate\_oidc\_session\_timeout (optional, number)                                                           : Maximum duration of the authentication session, in seconds.<br/><br/>- fixed\_response\_content\_type (optional, string): Content type. Valid values are “text/plain”, “text/css”, “text/html”, “application/javascript” and “application/json”.<br/>- fixed\_response\_message\_body (optional, string): Message body.<br/>- fixed\_response\_status\_code (optional, number) : TTP response code. Valid values are 2XX, 4XX, or 5XX.<br/><br/>- target\_groups (optional, set(object({key = optional(string), arn = optional(string), weight = optional(number)}))): Set of object of target groups. “key” is the “var.target\_groups”, “arn” is the ARN of the target group, “weight” is the range between 0 and 999. One of “arn” or “key” is mandatory, and you must exclusively use one of “arn” or “key”<br/><br/>- stickiness\_duration (optional, number): Time period, in seconds, during which requests from a client should be routed to the same target group. The range is 1-604800 seconds (7 days).<br/><br/>- redirect\_status\_code (optional, string): HTTP redirect code. The redirect is either permanent (“HTTP\_301”) or temporary (“HTTP\_302”).<br/>- redirect\_host (optional, string): Hostname. This component is not percent-encoded. The hostname can contain #{host}.<br/>- redirect\_path (optional, string): Absolute path, starting with the leading “/”. This component is not percent-encoded. The path can contain “#{host}”, “#{path}”, and “#{port}”.<br/>- redirect\_port (optional, any): Port. Specify a value from 1 to 65535 or “#{port}“.<br/>- redirect\_protocol (optional, string): Protocol. Valid values are “HTTP”, “HTTPS”, or “#{protocol}”.<br/>- redirect\_query (optional, string): Query parameters, URL-encoded when necessary, but not percent-encoded. Do not include the leading “?”.<br/><br/>- tags (optional, map(string))        : Tags to be applied and merge with this listener. | <pre>map(object({<br/>    port        = number<br/>    protocol    = string<br/>    action_type = string<br/><br/>    certificate_arn = optional(string)<br/>    ssl_policy      = optional(string)<br/><br/>    authenticate_cognito_user_pool_arn                       = optional(string)<br/>    authenticate_cognito_user_pool_client_id                 = optional(string)<br/>    authenticate_cognito_user_pool_domain                    = optional(string)<br/>    authenticate_cognito_authentication_request_extra_params = optional(map(object({ key = string, value = string })))<br/>    authenticate_cognito_on_unauthenticated_request          = optional(string)<br/>    authenticate_cognito_scope                               = optional(set(string))<br/>    authenticate_cognito_session_cookie_name                 = optional(string)<br/>    authenticate_cognito_session_timeout                     = optional(number)<br/><br/>    authenticate_oidc_authorization_endpoint              = optional(string)<br/>    authenticate_oidc_client_id                           = optional(string)<br/>    authenticate_oidc_client_secret                       = optional(string)<br/>    authenticate_oidc_issuer                              = optional(string)<br/>    authenticate_oidc_token_endpoint                      = optional(string)<br/>    authenticate_oidc_user_info_endpoint                  = optional(string)<br/>    authenticate_oidc_authentication_request_extra_params = optional(map(object({ key = string, value = string })))<br/>    authenticate_oidc_on_unauthenticated_request          = optional(string)<br/>    authenticate_oidc_scope                               = optional(set(string))<br/>    authenticate_oidc_session_cookie_name                 = optional(string)<br/>    authenticate_oidc_session_timeout                     = optional(number)<br/><br/>    fixed_response_content_type = optional(string)<br/>    fixed_response_message_body = optional(string)<br/>    fixed_response_status_code  = optional(number)<br/><br/>    target_groups = optional(set(object({<br/>      key    = optional(string)<br/>      arn    = optional(string)<br/>      weight = optional(number)<br/>    })))<br/><br/>    stickiness_duration = optional(number)<br/><br/>    redirect_status_code = optional(string)<br/>    redirect_host        = optional(string)<br/>    redirect_path        = optional(string)<br/>    redirect_port        = optional(any)<br/>    redirect_protocol    = optional(string)<br/>    redirect_query       = optional(string)<br/><br/>    tags = optional(map(string))<br/>  }))</pre> | `{}` | no |
| alb\_listeners\_tags | Tags to be applied to the ALB listeners resources, merged with var.tags. | `map(string)` | `{}` | no |
| application\_drop\_invalid\_header\_fields | Indicates whether HTTP headers with header fields that are not valid are removed by the load balancer (true) or routed to targets (false). Elastic Load Balancing requires that message header names contain only alphanumeric characters and hyphens. | `bool` | `true` | no |
| application\_enable\_xff\_client\_port | DEPRECATED. Use “var.application\_xff\_client\_port\_enabled” instead. | `bool` | `false` | no |
| application\_http2\_enabled | Whether to enable HTTP/2 in application load balancer or not. | `bool` | `true` | no |
| application\_idle\_timeout | The time in seconds that the connection is allowed to be idle. | `number` | `null` | no |
| application\_preserve\_host\_header | Whether to preserve the Host header in the HTTP request and send it to the target without any change or not. | `bool` | `false` | no |
| application\_tls\_version\_and\_cipher\_suite\_headers\_enabled | Whether to add the two headers (“x-amzn-tls-version” and “x-amzn-tls-cipher-suite”), which contain information about the negotiated TLS version and cipher suite or not. | `bool` | `false` | no |
| application\_waf\_arn | ARN of the WAF to associate with the ALB | `string` | `null` | no |
| application\_waf\_attachment\_enabled | Whether to associate the ALB on with the WAF “var.application\_waf\_arn” or not. | `bool` | `false` | no |
| application\_waf\_fail\_open\_enabled | Whether to allow a WAF-enabled load balancer to route requests to targets if it is unable to forward the request to AWS WAF or not. | `bool` | `false` | no |
| application\_xff\_client\_port\_enabled | Whether to preserve the “X-Forwarded-For” header with the source port that the client used to connect to the load balancer or not. | `bool` | `false` | no |
| application\_xff\_header\_processing\_mode | Determines how the load balancer will modify the X-Forwarded-For header in the HTTP request before sending the request to the target. The possible values are “append”, “preserve”, and “remove”. | `string` | `null` | no |
| cross\_zone\_load\_balancing\_enabled | Whether to enable cross-zone load balancing of the load balancer or not. | `bool` | `false` | no |
| customer\_owned\_ipv4\_pool | The ID of the customer-owned ipv4 pool to use for this load balancer. | `string` | `null` | no |
| deletion\_protection\_enabled | Whether to enable deletion protection of the load balancer via the AWS API or not. | `bool` | `false` | no |
| desync\_mitigation\_mode | Determines how the load balancer handles requests that might pose a security risk to an application due to HTTP desync. Valid values are “monitor”, “defensive”, “strictest”. | `string` | `null` | no |
| internal | Whether the load balancer is internal or not. | `bool` | `false` | no |
| ip\_address\_type | The type of IP addresses used by the subnets for your load balancer. The possible values are “ipv4” and “dualstack”. | `string` | `null` | no |
| is\_name\_prefix | Creates a unique name beginning with the specified prefix in “var.name”. | `bool` | `false` | no |
| listeners | Map of listeners. This applies only for “network” and “gateway” load balancer types. For “application” load balancer type, use “var.alb\_listeners”<br/>Keys are free values.<br/>- target\_group\_key (optional, string):      Key of the “var.target\_groups” where the listener must be attached to. Conflicts with “target\_group\_arn”. One of “target\_group\_arn” or “target\_group\_key” is mandatory.<br/>- target\_group\_arn (optional, string):      Arn of the target group where the listener must be attached to. Conflicts with “target\_group\_key”. One of “target\_group\_arn” or “target\_group\_key” is mandatory.<br/>- alpn\_policy      (optional, string):      Name of the Application-Layer Protocol Negotiation (ALPN) policy. Can be set if protocol is “TLS”. Valid values are “HTTP1Only”, “HTTP1Only”, “HTTP2Optional”, “HTTP2Preferred”, and “None”.<br/>- certificate\_arn  (optional, string):      ARN of the default SSL server certificate. Can be set if protocol is “TLS”.<br/>- ssl\_policy       (optional, string):      Name of the SSL Policy for the listener. Required if protocol “TLS”.<br/>- port             (optional, number):      Port on which the load balancer is listening. Not valid for “gateway” load balancers.<br/>- protocol         (optional, string):      Protocol for connections from clients to the load balancer. Valid values are “TCP”, “TLS”, “UDP”, and “TCP\_UDP”. Not valid for “gateway” load balancers.<br/>- tags             (optional, map(string)): Tags to be applied to the listener, merge with var.tags. | <pre>map(object({<br/>    target_group_key = optional(string)<br/>    target_group_arn = optional(string)<br/><br/>    alpn_policy     = optional(string)<br/>    certificate_arn = optional(string)<br/>    ssl_policy      = optional(string)<br/>    port            = optional(number)<br/>    protocol        = optional(string)<br/><br/>    tags = optional(map(string))<br/>  }))</pre> | `{}` | no |
| listeners\_tags | Tags to be applied and merge with all listeners. | `map(string)` | `{}` | no |
| load\_balancer\_tags | Tags to be applied to the load balancer, merge with var.tags. | `map(string)` | `{}` | no |
| name | The name of the load balancer. | `string` | `null` | no |
| security\_groups | A list of security group IDs to assign to the load balancer | `list(string)` | `null` | no |
| subnets | Map of subnets where to create the load balancer.<br/>Keys are free value. Values are:<br/>- subnet\_id     (string, required): The ID of the subnet. You can specify only one subnet per Availability Zone.<br/>- allocation\_id (string, optional): The allocation ID of the Elastic IP address for an internet-facing load balancer.<br/>- ipv6\_address  (string, optional): The IPv6 address. You associate IPv6 CIDR blocks with your VPC and choose the subnets where you launch both internet-facing and internal Application Load Balancers or Network Load Balancers.<br/>- ipv4\_address  (string, optional): The private IPv4 address for an internal load balancer. | <pre>map(object({<br/>    subnet_id     = string<br/>    allocation_id = optional(string)<br/>    ipv6_address  = optional(string)<br/>    ipv4_address  = optional(string)<br/>  }))</pre> | `null` | no |
| tags | Tags to be applied on all resources of this module. | `map(string)` | `{}` | no |
| target\_group\_tags | Tags to applied and merge with all target groups. | `map(string)` | `null` | no |
| target\_groups | Target Groups.<br/>Keys are free values.<br/>- name (required, string)                              : Name of the target group.<br/>- type (required, string)                              : Type of target that you must specify when registering targets with this target group. Must be on of “instance”, “ip”, “alb” or “lambda”.<br/>- is\_name\_prefix (optional, bool, false)               : Whether to creates a unique name beginning with the specified prefix in “name” or not.<br/>- connection\_termination (optional, bool)              : Whether to terminate connections at the end of the deregistration timeout on Network Load Balancers or not.<br/>- deregistration\_delay (optional, number)              : Amount time for Elastic Load Balancing to wait before changing the state of a deregistering target from draining to unused. The range is 0-3600 seconds.<br/>- lambda\_multi\_value\_headers\_enabled  (optional, bool) : Whether the request and response headers exchanged between the load balancer and the Lambda function include arrays of values or strings. Only applies when target\_type is lambda.<br/>- load\_balancing\_algorithm\_type (optional, string)     : Determines how the load balancer selects targets when routing requests. Only applicable for Application Load Balancer Target Groups. The value is “round\_robin” or “least\_outstanding\_requests”.<br/>- load\_balancing\_cross\_zone\_enabled (optional, bool)   : Whether to enable cross zone load balancing or not. If not set, it takes the load balancer configuration.<br/>- port (optional, number)                              : Port on which targets receive traffic, unless overridden when registering a specific target. Required when type is one of “instance”, “ip” or “alb”.<br/>- preserve\_client\_ip (optional, bool)                  : Whether to preserve client IP or not. Only applicable to network load balancer<br/>- protocol\_version (optional, string)                  : Only applicable when protocol is “HTTP” or “HTTPS”. The protocol version. Specify “GRPC” to send requests to targets using gRPC. Specify “HTTP2” to send requests to targets using HTTP/2.<br/>- protocol (optional, string)                          : Protocol to use for routing traffic to the targets. Must be one of “GENEVE”, “HTTP”, “HTTPS”, “TCP”, “TCP\_UDP”, “TLS”, or “UDP”. Required when type is one of “instance”, “ip” or “alb”.<br/>- proxy\_protocol\_v2 (optional, bool)                   : Whether to enable support for proxy protocol v2 on Network Load Balancers or not.<br/>- slow\_start (optional, number))                       : Amount time for targets to warm up before the load balancer sends them a full share of requests. The range is 30-900 seconds or 0 to disable. This apply only on application load balancer. This timer is independent with AutoScaling grace period.<br/>- ip\_address\_type (optional, string)                   : The type of IP addresses used by the target group, only supported when target type is set to ip. Possible values are “ipv4“ or “ipv6”.<br/>- tags (optional, map(string), {})                     : Tags to be merge with this target group.<br/><br/>- health\_check\_enabled (optional, bool, true)         : Whether to enable health check or not.<br/>- health\_check\_healthy\_threshold (optional, number)   : Number of consecutive health check successes required before considering a target healthy. The range is 2-10.<br/>- health\_check\_interval (optional, number)            : Approximate amount of time, in seconds, between health checks of an individual target. The range is 5-300.<br/>- health\_check\_matcher (optional, list(string))       : Response codes to use when checking for a healthy responses from a target. You can specify multiple values (for example, "200,202" for HTTP(s) or "0,12" for GRPC) or a range of values (for example, "200-299" or "0-99"). Required for HTTP/HTTPS/GRPC ALB. Only applies to Application Load Balancers (i.e., HTTP/HTTPS/GRPC) not Network Load Balancers (i.e., TCP)<br/>- health\_check\_path (optional, string)                : Destination for the health check request. Required for HTTP/HTTPS ALB and HTTP NLB. Only applies to HTTP/HTTPS.<br/>- health\_check\_port (optional, number)                : The port the load balancer uses when performing health checks on targets.<br/>- health\_check\_protocol (optional, string)            : Protocol the load balancer uses when performing health checks on targets. Must be either “TCP”, “HTTP”, or “HTTPS”. The “TCP” protocol is not supported for health checks if the protocol of the target group is “HTTP” or “HTTPS”.<br/>- health\_check\_timeout (optional, number)             : Amount of time, in seconds, during which no response from a target means a failed health check. The range is 2–120 seconds.<br/>- health\_check\_unhealthy\_threshold (optional, number) : Number of consecutive health check failures required before considering a target unhealthy. The range is 2-10.<br/><br/>- stickiness\_type (optional, string)            : The type of sticky sessions. The only current possible values are “lb\_cookie”, “app\_cookie” for ALBs, “source\_ip” for NLBs, and “source\_ip\_dest\_ip”, “source\_ip\_dest\_ip\_proto” for GWLBs.<br/>- stickiness\_cookie\_duration (optional, number) : Only used when the type is “lb\_cookie”. The time period, in seconds, during which requests from a client should be routed to the same target. After this time period expires, the load balancer-generated cookie is considered stale. The range is 1 second to 1 week (604800 seconds).<br/>- stickiness\_cookie\_name (optional, string)     : Name of the application based cookie. AWSALB, AWSALBAPP, and AWSALBTG prefixes are reserved and cannot be used. Only needed when type is “app\_cookie”.<br/><br/>- gateway\_target\_failover\_enabled (optional, bool, false)     : Whether to enabled the gateway target failover or not.<br/>- gateway\_target\_failover\_on\_deregistration (optional,string) : Indicates how the GWLB handles existing flows when a target is deregistered. Possible values are “rebalance” and “no\_rebalance”. Must match the attribute value set for on\_unhealthy.<br/>- gateway\_target\_failover\_on\_unhealthy (optional, string)     : Indicates how the GWLB handles existing flows when a target is unhealthy. Possible values are “rebalance” and “no\_rebalance”. Must match the attribute value set for on\_deregistration.<br/><br/>- attachments (optional, map(object(see below))): Target to attached to target groups.<br/>  Keys are free values.<br/>  - id (required, string)               : The ID of the target. This is the Instance ID for an instance. If the target type is ip, specify an IP address. If the target type is lambda, specify the Lambda function ARN. If the target type is alb, specify the ALB ARN.<br/>  - availability\_zone (optional, string): The Availability Zone where the IP address of the target is to be registered. If the private IP address is outside of the VPC scope, this value must be set to all.<br/>  - port (optional, number)             : The port on which targets receive traffic | <pre>map(object({<br/>    name                               = string<br/>    type                               = string<br/>    is_name_prefix                     = optional(bool, false)<br/>    connection_termination             = optional(bool)<br/>    deregistration_delay               = optional(number)<br/>    lambda_multi_value_headers_enabled = optional(bool)<br/>    load_balancing_algorithm_type      = optional(string)<br/>    load_balancing_cross_zone_enabled  = optional(bool)<br/>    port                               = optional(number)<br/>    preserve_client_ip                 = optional(bool)<br/>    protocol_version                   = optional(string)<br/>    protocol                           = optional(string)<br/>    proxy_protocol_v2                  = optional(bool)<br/>    slow_start                         = optional(number)<br/><br/>    health_check_enabled             = optional(bool, true)<br/>    health_check_healthy_threshold   = optional(number)<br/>    health_check_interval            = optional(number)<br/>    health_check_matcher             = optional(list(string))<br/>    health_check_path                = optional(string)<br/>    health_check_port                = optional(number)<br/>    health_check_protocol            = optional(string)<br/>    health_check_timeout             = optional(number)<br/>    health_check_unhealthy_threshold = optional(number)<br/><br/>    stickiness_type            = optional(string)<br/>    stickiness_cookie_duration = optional(number)<br/>    stickiness_cookie_name     = optional(string)<br/><br/>    gateway_target_failover_enabled           = optional(bool, false)<br/>    gateway_target_failover_on_deregistration = optional(string)<br/>    gateway_target_failover_on_unhealthy      = optional(string)<br/><br/>    ip_address_type = optional(string)<br/><br/>    attachments = optional(map(object({<br/>      id                = string<br/>      availability_zone = optional(string)<br/>      port              = optional(number)<br/>    })))<br/>    tags = optional(map(string), {})<br/><br/>  }))</pre> | `{}` | no |
| type | The type of load balancer to create. Possible values are “application”, “gateway”, or “network”. | `string` | `null` | no |
| vpc\_id | The ID of the VPC where to deploy resources. | `string` | `null` | no |

## Outputs

| Name | Description |
|------|-------------|
| aws\_lb | n/a |
| aws\_lb\_listener\_rules | n/a |
| aws\_lb\_listeners | n/a |
| aws\_lb\_target\_groups | n/a |
| precomputed | n/a |
<!-- END_TF_DOCS -->
